'' =================================================================================================
''
''   File....... jm_nunchuk_test_v2.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.term
''   Started.... 
''   Updated.... 06 MAR 2011
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS
  

obj

  wii  : "jm_nunchuk_ez_v2"                                     ' polled Wii nunchuk
  term : "fullduplexserial"                                     ' for terminal output


pub main | t

  wii.init(SCL, SDA, wii#NC_OTHER)                              ' setup Wii on EE pins
  term.start(RX1, TX1, %0000, 115_200)                          ' start terminal cog
  pause(1)

  term.str(string(CLS, "Nunchuk Demo", CR, "-- manual scan"))

  t := cnt
  repeat
    wii.scan                                                    ' scan Wii nunchuk
    term.str(string(HOME, LF, LF, LF))                          ' position for report 
    
    term.str(string("Joy X... "))
    term.dec(wii.joyx)
    term.tx(CLREOL)
    term.tx(CR)

    term.str(string("Joy Y... "))
    term.dec(wii.joyy)
    term.tx(CLREOL)
    term.tx(CR)

    term.str(string("Acc X... "))
    term.dec(wii.accx)
    term.tx(CLREOL)
    term.tx(CR)

    term.str(string("Acc Y... "))
    term.dec(wii.accy)
    term.tx(CLREOL)
    term.tx(CR)

    term.str(string("Acc Z... "))
    term.dec(wii.accz)
    term.tx(CLREOL)
    term.tx(CR)

    term.str(string("Btns.... "))
    'term.bin(wii.buttons, 2)
    term.tx(wii.btnz + "0")
    term.tx(wii.btnc + "0")
    term.tx(CLREOL)
    
    waitcnt(t += constant(100 * MS_001)) 

 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)

       
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}